(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Capnp = Package['sandstorm-capnp'].Capnp;
var meteorInstall = Package.modules.meteorInstall;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var Symbol = Package['ecmascript-runtime-server'].Symbol;
var Map = Package['ecmascript-runtime-server'].Map;
var Set = Package['ecmascript-runtime-server'].Set;

/* Package-scope variables */
var SandstormPowerbox;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                               //
                                                                                                                      //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                              // 2
// All rights reserved.                                                                                               // 3
//                                                                                                                    // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                    // 5
// you may not use this file except in compliance with the License.                                                   // 6
// You may obtain a copy of the License at                                                                            // 7
//                                                                                                                    // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       // 9
//                                                                                                                    // 10
// Unless required by applicable law or agreed to in writing, software                                                // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                  // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           // 13
// See the License for the specific language governing permissions and                                                // 14
// limitations under the License.                                                                                     // 15
var Crypto = Npm.require("crypto");                                                                                   // 17
                                                                                                                      //
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                        // 18
var Grain = Capnp.importSystem("sandstorm/grain.capnp"); // TODO(cleanup): lift this out of a package so it can share with async-helpers.js
                                                                                                                      //
var Future = Npm.require("fibers/future");                                                                            // 22
                                                                                                                      //
var promiseToFuture = function (promise) {                                                                            // 23
  var result = new Future();                                                                                          // 24
  promise.then(result.return.bind(result), result.throw.bind(result));                                                // 25
  return result;                                                                                                      // 26
};                                                                                                                    // 27
                                                                                                                      //
var waitPromise = function (promise) {                                                                                // 29
  return promiseToFuture(promise).wait();                                                                             // 30
};                                                                                                                    // 31
                                                                                                                      //
function encodePowerboxDescriptor(desc) {                                                                             // 33
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                                     // 38
                                                                                                                      //
Meteor.methods({                                                                                                      // 40
  newFrontendRef: function (sessionId, frontendRefRequest) {                                                          // 41
    // Completes a powerbox request for a frontendRef capability.                                                     // 42
    check(sessionId, String); // frontendRefRequest is type-checked by frontendRefRegistry.validate(), below.         // 43
                                                                                                                      //
    var db = this.connection.sandstormDb;                                                                             // 46
    var frontendRefRegistry = this.connection.frontendRefRegistry;                                                    // 47
    var session = db.collections.sessions.findOne({                                                                   // 49
      _id: sessionId,                                                                                                 // 50
      userId: this.userId || {                                                                                        // 50
        $exists: false                                                                                                // 50
      }                                                                                                               // 50
    });                                                                                                               // 50
                                                                                                                      //
    if (!session) {                                                                                                   // 51
      throw new Meteor.Error(403, "Invalid session ID");                                                              // 52
    }                                                                                                                 // 53
                                                                                                                      //
    var _frontendRefRegistry$ = frontendRefRegistry.validate(db, session, frontendRefRequest),                        // 41
        descriptor = _frontendRefRegistry$.descriptor,                                                                // 41
        requirements = _frontendRefRegistry$.requirements,                                                            // 41
        frontendRef = _frontendRefRegistry$.frontendRef;                                                              // 41
                                                                                                                      //
    descriptor = encodePowerboxDescriptor(descriptor);                                                                // 57
    var grainId = session.grainId;                                                                                    // 59
    var apiTokenOwner = {                                                                                             // 60
      clientPowerboxRequest: {                                                                                        // 61
        grainId: grainId,                                                                                             // 62
        sessionId: session._id                                                                                        // 63
      }                                                                                                               // 61
    };                                                                                                                // 60
    var cap = frontendRefRegistry.create(db, frontendRef, requirements);                                              // 67
    var sturdyRef = waitPromise(cap.save(apiTokenOwner)).sturdyRef.toString();                                        // 68
    cap.close();                                                                                                      // 69
    return {                                                                                                          // 70
      sturdyRef: sturdyRef,                                                                                           // 70
      descriptor: descriptor                                                                                          // 70
    };                                                                                                                // 70
  },                                                                                                                  // 71
  fulfillUiViewRequest: function (sessionId, obsolete1, grainId, petname, roleAssignment, ownerGrainId) {             // 73
    var db = this.connection.sandstormDb;                                                                             // 74
    check(sessionId, String);                                                                                         // 75
    check(grainId, String);                                                                                           // 76
    check(roleAssignment, db.roleAssignmentPattern);                                                                  // 77
    check(petname, String);                                                                                           // 78
    check(ownerGrainId, String);                                                                                      // 79
                                                                                                                      //
    if (!this.userId) {                                                                                               // 81
      throw new Meteor.Error(403, "Must be logged in");                                                               // 82
    }                                                                                                                 // 83
                                                                                                                      //
    var provider = {                                                                                                  // 85
      accountId: this.userId                                                                                          // 86
    };                                                                                                                // 85
    var title = db.userGrainTitle(grainId, this.userId);                                                              // 89
    var descriptor = encodePowerboxDescriptor({                                                                       // 91
      tags: [{                                                                                                        // 92
        id: Grain.UiView.typeId,                                                                                      // 93
        value: Capnp.serialize(Grain.UiView.PowerboxTag, {                                                            // 94
          title: title                                                                                                // 94
        })                                                                                                            // 94
      }]                                                                                                              // 93
    });                                                                                                               // 91
    var owner = {                                                                                                     // 99
      clientPowerboxRequest: {                                                                                        // 100
        grainId: ownerGrainId,                                                                                        // 101
        sessionId: sessionId                                                                                          // 102
      }                                                                                                               // 100
    };                                                                                                                // 99
    var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);       // 106
    return {                                                                                                          // 109
      sturdyRef: result.token,                                                                                        // 110
      descriptor: descriptor                                                                                          // 111
    };                                                                                                                // 109
  }                                                                                                                   // 113
});                                                                                                                   // 40
                                                                                                                      //
var PowerboxOption = function () {                                                                                    //
  function PowerboxOption(fields) {                                                                                   // 117
    (0, _classCallCheck3.default)(this, PowerboxOption);                                                              // 117
                                                                                                                      //
    _.extend(this, fields);                                                                                           // 118
  }                                                                                                                   // 119
                                                                                                                      //
  PowerboxOption.prototype.intersect = function () {                                                                  //
    function intersect(other) {                                                                                       //
      // Intersect two options with the same ID. Used when combining matches from multiple tags                       // 122
      // in the same descriptor. The tags are a conjunction.                                                          // 123
      //                                                                                                              // 124
      // Returns true if there was any overlap, or false if there was no overlap and therefore the                    // 125
      // option should be dropped.                                                                                    // 126
      //                                                                                                              // 127
      // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                     // 128
      if (other._id != this._id) {                                                                                    // 130
        throw new Error("can only merge options with the same ID");                                                   // 131
      }                                                                                                               // 132
                                                                                                                      //
      if (other.grainId) {                                                                                            // 134
        if (this.uiView && !other.uiView) delete this.uiView;                                                         // 135
        if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                       // 136
        return !!(this.uiView || this.hostedObject);                                                                  // 137
      } else if ((this.frontendRef || {}).verifiedEmail) {                                                            // 138
        // Try to hint which verifierId matched.                                                                      // 139
        if (this.frontendRef.verifiedEmail.verifierId) {                                                              // 140
          if (other.frontendRef.verifiedEmail.verifierId) {                                                           // 141
            // Can't match multiple verifiers at once.                                                                // 142
            return false;                                                                                             // 143
          }                                                                                                           // 144
        } else if (other.frontendRef.verifiedEmail.verifierId) {                                                      // 145
          // One request did not specify any verifierId, the other did, and both matched, so use                      // 146
          // the verifierId.                                                                                          // 147
          this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                     // 148
        }                                                                                                             // 149
                                                                                                                      //
        return true;                                                                                                  // 151
      } else {                                                                                                        // 152
        // No intersection logic needed for other types.                                                              // 153
        return true;                                                                                                  // 154
      }                                                                                                               // 155
    }                                                                                                                 // 156
                                                                                                                      //
    return intersect;                                                                                                 //
  }();                                                                                                                //
                                                                                                                      //
  PowerboxOption.prototype.union = function () {                                                                      //
    function union(other) {                                                                                           //
      // Union two options with the same ID. Used when combining matches from multiple descriptors.                   // 159
      // The descriptors are a disjunction.                                                                           // 160
      //                                                                                                              // 161
      // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                     // 162
      if (other._id != this._id) {                                                                                    // 164
        throw new Error("can only merge options with the same ID");                                                   // 165
      }                                                                                                               // 166
                                                                                                                      //
      if (other.grainId) {                                                                                            // 168
        if (!this.uiView && other.uiView) this.uiView = other.uiView;                                                 // 169
        if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                         // 170
      } else if ((this.frontendRef || {}).verifiedEmail) {                                                            // 171
        // If this doesn't have a verifierId but other does, copy it over.                                            // 172
        if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {               // 173
          this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                     // 175
        }                                                                                                             // 176
      }                                                                                                               // 177
    }                                                                                                                 // 178
                                                                                                                      //
    return union;                                                                                                     //
  }();                                                                                                                //
                                                                                                                      //
  PowerboxOption.prototype.subtract = function () {                                                                   //
    function subtract(other) {                                                                                        //
      // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                     // 181
      // if there's anything left, false otherwise.                                                                   // 182
      if (other._id != this._id) {                                                                                    // 184
        throw new Error("can only merge options with the same ID");                                                   // 185
      }                                                                                                               // 186
                                                                                                                      //
      if (other.grainId) {                                                                                            // 188
        if (this.uiView && other.uiView) delete this.uiView;                                                          // 189
        if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                        // 190
        return !!(this.uiView || this.hostedObject);                                                                  // 191
      } else {                                                                                                        // 192
        return false;                                                                                                 // 193
      }                                                                                                               // 194
    }                                                                                                                 // 195
                                                                                                                      //
    return subtract;                                                                                                  //
  }();                                                                                                                //
                                                                                                                      //
  return PowerboxOption;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
function registerUiViewQueryHandler(frontendRefRegistry) {                                                            // 198
  // TODO(cleanup): Maybe this belongs in a different file? But where?                                                // 199
  frontendRefRegistry.register({                                                                                      // 201
    typeId: Grain.UiView.typeId,                                                                                      // 202
    query: function (db, userId, value) {                                                                             // 204
      if (!userId) return []; // TODO(someday): Allow `value` to specify app IDs to filter for.                       // 205
                                                                                                                      //
      var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                            // 209
        return token.grainId;                                                                                         // 209
      });                                                                                                             // 209
      var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                                // 210
        return grain._id;                                                                                             // 210
      });                                                                                                             // 210
      return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                    // 212
        return new PowerboxOption({                                                                                   // 213
          _id: "grain-" + grainId,                                                                                    // 214
          grainId: grainId,                                                                                           // 215
          uiView: {},                                                                                                 // 216
          cardTemplate: "grainPowerboxCard",                                                                          // 217
          configureTemplate: "uiViewPowerboxConfiguration"                                                            // 218
        });                                                                                                           // 213
      });                                                                                                             // 220
    }                                                                                                                 // 221
  });                                                                                                                 // 201
}                                                                                                                     // 223
                                                                                                                      //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                              // 225
  var _this = this;                                                                                                   // 225
                                                                                                                      //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                             // 226
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                           // 227
  // packed format and base64-encoded. The publish populates a pseudo-collection called                               // 228
  // `powerboxOptions`. Each item has the following fields:                                                           // 229
  //                                                                                                                  // 230
  //   _id: Unique identifier string.                                                                                 // 231
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"                    // 232
  //        and is only guaranteed to be unique because we currently don't allow a client to have                     // 233
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness                  // 234
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`               // 235
  //        to be either a string or an `ObjectID`.                                                                   // 236
  //   requestId: The value of `requestId` that was passed in when subscribing.                                       // 237
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                            // 238
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                        // 239
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                      // 240
  //       of the field is the same as ApiTokens.frontendRef.                                                         // 241
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                        // 242
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                        // 243
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user                     // 244
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an                     // 245
  //       object with the fields:                                                                                    // 246
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user                     // 247
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                      // 248
  //         permissions when requesting a plain UiView.                                                              // 249
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                      // 250
  //       match the query. If selected, a request session to the grain embedded should be shown                      // 251
  //       embedded in the powerbox and the same request should be passed to it. Only present when                    // 252
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.                     // 253
  //   cardTemplate: Names the client-side template to use to display this powerbox option. The                       // 254
  //       template's data context will be a "card" object as returned by                                             // 255
  //       SandstormPowerboxRequest.filteredCardData(). Also, the template definition (in client                      // 256
  //       code) may have a static method `powerboxIconSrc` which takes the card as a parameter                       // 257
  //       and returns the URL of the icon to display next to the option.                                             // 258
  //   configureTemplate: If selecting this option should then show a further dialog, names the                       // 259
  //       client-side template for that dialog.                                                                      // 260
  //   ...: Other fields may be added for consumption by the client-side template.                                    // 261
  check(requestId, String);                                                                                           // 263
  check(descriptorList, [String]);                                                                                    // 264
  var results = {};                                                                                                   // 266
  var db = this.connection.sandstormDb;                                                                               // 267
  var frontendRefRegistry = this.connection.frontendRefRegistry;                                                      // 268
                                                                                                                      //
  if (descriptorList.length > 0) {                                                                                    // 270
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                          // 271
      // Decode the descriptor.                                                                                       // 272
      // TODO(now): Also single-segment? Canonical?                                                                   // 273
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                           // 275
      var queryDescriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), {        // 276
        packed: true                                                                                                  // 279
      });                                                                                                             // 279
      if (!queryDescriptor.tags || queryDescriptor.tags.length === 0) return {}; // Expand each tag into a match map.
                                                                                                                      //
      var tagMatches = queryDescriptor.tags.map(function (tag) {                                                      // 284
        var result = {};                                                                                              // 285
        frontendRefRegistry.query(db, _this.userId, tag).forEach(function (option) {                                  // 287
          result[option._id] = new PowerboxOption(option);                                                            // 288
        });                                                                                                           // 289
        return result;                                                                                                // 291
      }); // Intersect two tags' matches.                                                                             // 292
                                                                                                                      //
      var matches = tagMatches.reduce(function (a, b) {                                                               // 295
        for (var id in meteorBabelHelpers.sanitizeForInObject(a)) {                                                   // 296
          if (id in b) {                                                                                              // 297
            if (!a[id].intersect(b[id])) {                                                                            // 298
              // Empty intersection.                                                                                  // 299
              delete a[id];                                                                                           // 300
            }                                                                                                         // 301
          } else {                                                                                                    // 302
            // This match only exists in a, not b, so delete it.                                                      // 303
            delete a[id];                                                                                             // 304
          }                                                                                                           // 305
        }                                                                                                             // 306
                                                                                                                      //
        return a;                                                                                                     // 308
      }); // Search among the user's grains for hosted objects that match.                                            // 309
                                                                                                                      //
      if (_this.userId) {                                                                                             // 313
        var user = Meteor.users.findOne(_this.userId); // Find all grains shared to this user.                        // 314
                                                                                                                      //
        var sharedGrainIds = db.userApiTokens(_this.userId).map(function (token) {                                    // 317
          return token.grainId;                                                                                       // 317
        }); // Among all grains owned by the user or shared with the user, search for grains having                   // 317
        // any powerbox tag IDs matching the tag IDs in the query.                                                    // 320
                                                                                                                      //
        db.collections.grains.find({                                                                                  // 321
          $or: [{                                                                                                     // 323
            userId: _this.userId                                                                                      // 323
          }, {                                                                                                        // 323
            _id: {                                                                                                    // 323
              $in: sharedGrainIds                                                                                     // 323
            }                                                                                                         // 323
          }],                                                                                                         // 323
          "cachedViewInfo.matchRequests.tags.id": {                                                                   // 324
            $in: queryDescriptor.tags.map(function (tag) {                                                            // 325
              return tag.id;                                                                                          // 325
            })                                                                                                        // 325
          }                                                                                                           // 325
        }, {                                                                                                          // 322
          fields: {                                                                                                   // 326
            "cachedViewInfo.matchRequests": 1                                                                         // 326
          }                                                                                                           // 326
        }).forEach(function (grain) {                                                                                 // 326
          // Filter down to grains that actually have a matching descriptor.                                          // 328
          var alreadyMatched = false;                                                                                 // 329
          grain.cachedViewInfo.matchRequests.forEach(function (grainDescriptor) {                                     // 330
            if (alreadyMatched) return; // Build map of descriptor tags by ID.                                        // 331
                                                                                                                      //
            var grainTagsById = {};                                                                                   // 334
            grainDescriptor.tags.forEach(function (tag) {                                                             // 335
              grainTagsById[tag.id] = tag.value;                                                                      // 336
            });                                                                                                       // 337
            var allMatched = true;                                                                                    // 339
            queryDescriptor.tags.forEach(function (queryTag) {                                                        // 340
              if (!allMatched) return;                                                                                // 341
                                                                                                                      //
              if (queryTag.id in grainTagsById) {                                                                     // 343
                var value = grainTagsById[queryTag.id]; // Null values match everything, so only pay attention if non-null.
                                                                                                                      //
                if (value && queryTag.value) {                                                                        // 346
                  if (!Capnp.matchPowerboxQuery(queryTag.value, value)) {                                             // 347
                    allMatched = false;                                                                               // 348
                  }                                                                                                   // 349
                }                                                                                                     // 350
              } else {                                                                                                // 351
                allMatched = false;                                                                                   // 352
              }                                                                                                       // 353
            });                                                                                                       // 354
                                                                                                                      //
            if (allMatched) {                                                                                         // 356
              alreadyMatched = true;                                                                                  // 357
              var option = new PowerboxOption({                                                                       // 358
                _id: "grain-" + grain._id,                                                                            // 359
                grainId: grain._id,                                                                                   // 360
                hostedObject: {},                                                                                     // 361
                cardTemplate: "grainPowerboxCard",                                                                    // 362
                configureTemplate: "uiViewPowerboxConfiguration" // TODO(cleanup): rename                             // 363
                                                                                                                      //
              });                                                                                                     // 358
                                                                                                                      //
              if (option._id in matches) {                                                                            // 365
                matches[option._id].union(option);                                                                    // 366
              } else {                                                                                                // 367
                matches[option._id] = option;                                                                         // 368
              }                                                                                                       // 369
            }                                                                                                         // 370
          });                                                                                                         // 371
        });                                                                                                           // 372
      }                                                                                                               // 373
                                                                                                                      //
      return {                                                                                                        // 375
        descriptor: queryDescriptor,                                                                                  // 375
        matches: matches                                                                                              // 375
      };                                                                                                              // 375
    }); // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're                // 376
    //   supposed to compare descriptors to determine which ones are more specific than which                         // 379
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:                   // 380
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                           // 381
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                        // 382
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                        // 383
    //   list.                                                                                                        // 384
                                                                                                                      //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                          // 386
      if (clause.matchQuality === "unacceptable") {                                                                   // 387
        // Remove b's matches from a.                                                                                 // 388
        for (var id in meteorBabelHelpers.sanitizeForInObject(clause.matches)) {                                      // 389
          if (id in finalMatches) {                                                                                   // 390
            if (!finalMatches[id].subtract(clause.matches[id])) {                                                     // 391
              delete finalMatches[id];                                                                                // 392
            }                                                                                                         // 393
          }                                                                                                           // 394
        }                                                                                                             // 395
                                                                                                                      //
        return finalMatches;                                                                                          // 397
      } else {                                                                                                        // 398
        for (var _id in meteorBabelHelpers.sanitizeForInObject(clause.matches)) {                                     // 399
          if (_id in finalMatches) {                                                                                  // 400
            finalMatches[_id].union(clause.matches[_id]);                                                             // 401
          } else {                                                                                                    // 402
            finalMatches[_id] = clause.matches[_id];                                                                  // 403
          }                                                                                                           // 404
                                                                                                                      //
          if (clause.matchQuality === "preferred") {                                                                  // 406
            finalMatches[_id].matchQuality = "preferred";                                                             // 407
          }                                                                                                           // 408
        }                                                                                                             // 409
                                                                                                                      //
        return finalMatches;                                                                                          // 411
      }                                                                                                               // 412
    }, {});                                                                                                           // 413
                                                                                                                      //
    for (var id in meteorBabelHelpers.sanitizeForInObject(matches)) {                                                 // 415
      if (!matches[id].matchQuality) {                                                                                // 416
        matches[id].matchQuality = "acceptable";                                                                      // 417
      }                                                                                                               // 418
                                                                                                                      //
      matches[id].requestId = requestId;                                                                              // 420
      this.added("powerboxOptions", id, matches[id]);                                                                 // 421
    }                                                                                                                 // 422
  } // TODO(someday): Make reactive? Seems annoying.                                                                  // 423
                                                                                                                      //
                                                                                                                      //
  this.ready();                                                                                                       // 427
});                                                                                                                   // 428
SandstormPowerbox = {                                                                                                 // 430
  registerUiViewQueryHandler: registerUiViewQueryHandler                                                              // 430
};                                                                                                                    // 430
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{
  "extensions": [
    ".js",
    ".json"
  ]
});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerbox: SandstormPowerbox
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
